const WALKME_COOKIE_MATCH = new Array('refererId', 'refererType', 'b', 'refererUrl', 'camp', 'adgr', 'matc', 'sear', 'adin', 'plac', 'land', 'eco', 'pitch', 'cmpTa', 'cmpG', 'cmpType', 'abt1', 'abt2', 'para1', 'para2', 'para3', 'gclid', 'campid', 'adtext', 'keyw1', 'keyw2', 'keyw3', 'keyw', 'luid', 'formName', 'wm-fp', 'formDataCookie', 'oldRefererId', 'PcampId', '3wsum', 'sbtyp', 'integcamp', 'obj', 'strt', 'Dealdep', 'case', 'sfcmpid');

const WALKME_VALIDATION_MESSAGES = {
    onlyLetters: "Please enter only letters",
    emptyField: "Please fill the required field",
    emptyDate: "Please select any date option",
    emptyFullName: "Please enter full name",
    emptyPhone: "Please enter phone number",
    validWorkEmail: "Please enter a valid work email",
    emptyWorkEmail: "Please fill in your work email",
    emptyEmail: "Please enter email",
    invalidEmail: "Please enter a valid email",
    phoneNumberNumeric: "The phone number must be numeric.",
    identicalPassword: "The passwords must be identical.",
    emptyPassword: "Please fill in your password",
    emptyRepeatPassword: "Please fill in your repeated password",
    passwordFormat: "Your password must contain at least 8 characters, at least 1 lowercase letter, 1 uppercase letter, and a special character (!@#$%^&*)",
    thankInterest: "Thanks for your interest, we will get back to you shortly.",
    termsCondition: "Please accept the terms & conditions.",
    answerSelect: "Please select an answer.",
    maxemaillength: "The maximum length is 50 characters",
    fillName: "Please fill in your name",
    fillCompanyName: "Please fill in your company name",
    fillCompanyEmail: "Please fill in your company email",
    emptyJobTitle: "Please fill in your job title",
    emptyRegion: "Please select your region",
};
const email_regex = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

class WalkMeFormValidation {
    validateWorkEmail(email) {
        var workEmailRegex = /^([\w-'\.]+@(?!gmail\.[a-zA-Z])(?!yahoo\.[a-zA-Z])([\w-]+\.)+[\w-]{2,10})?$/;

        if (window.location.href.indexOf("/lpages/dynamics-uii/") >= 1) {
            workEmailRegex = /^([\w-+'\.]+@(?!gmail\.[a-zA-Z])(?!yahoo\.[a-zA-Z])([\w-]+\.)+[\w-]{2,10})?$/;
        }
        const emailDomain = email.substring(email.lastIndexOf(".") + 1);

        if (email.length > 0 && emailDomain.length > 8) {
            return 1;
        }

        if (email.length > 0 && !email_regex.test(email)) {
            return 1;
        }

        if (email.length > 0 && !workEmailRegex.test(email)) {
            return 2;
        }
        return 3;
    }

    async validateEmailDomain(email,token) {
        try{
            let base_url = 'https://marapi.walkme.com';

            if (window.location.hostname.indexOf('walkmeqa') > -1 || window.location.hostname.indexOf('localhost') > -1 || window.location.hostname.indexOf('wpengine') > -1) {
                base_url = 'https://marapi.walkmeqa.com';
            }

            const url = base_url + '/wp-json/walkme/v1/email/validate/?email=' + email;
            const requestOptions = {
                method: 'POST',  
                cache: 'no-cache',                
                headers: {                    
                    'Authorization': 'Bearer ' + token                    
                },
            };
            const response = await fetch(url, requestOptions);            
            if (!response.ok) {
                throw new Error(`HTTP error! status: ${response.status}`);               
            }
            const res = await response.text();
            return res;
        }catch(error){              
            return 4;  
        }
    }

    async validateWorkEmailListNew(email) {
        if (this.validateWorkEmail(email) == 3) {
            var token = "eRFnq8eW5897fW3T0YwtVQy3bsggFrBMy1FhMUducI5AbmpCeMsQpY6EQLXR+pfGoR6Gla70hDRlIiIF1VT+lHjEbHiy2HGlDM7zXRkRnk4=";
            const domain_status = await this.validateEmailDomain(email,token);  
            
            if (domain_status == 1) {                
                return true;
            }
        }

        return false;
    }

    validateWorkEmailList(email) {
        if (typeof workEmailArrValues !== "undefined" && email.length > 0) {
            var email_domain = email.substring(email.lastIndexOf("@") + 1);
            if (workEmailArrValues.indexOf(email_domain) > -1) {
                return true;
            }
        }
        return false;
    }
    validatePhoneNumber(phone) {
        var phoneRegex = /^\d+$/;

        if (phone.length > 0 && !phoneRegex.test(phone)) {
            return false;
        }
        return true;
    }
    validateInvalidEmail(email) {

        if (email.length > 0 && !email_regex.test(email)) {
            return false;
        }
        return true;
    }
    validateSpecialChars(value) {
        var sym_regex = /[&(){}\[\]"'<>!]/;

        if (value.length > 0 && !sym_regex.test(value)) {
            return false;
        }

        return true;
    }
    validatePassword(value) {
        var passowrd_regx = /^(?=.*?[A-Z])(?=.*?[a-z])(?=.*?[#?!@$%^&*-]).{8,}$/;
        if (value.length > 0 && !passowrd_regx.test(value)) {
            return false;
        }

        return true;
    }
    wmMessageFormat(name, type) {
        if (type == "wrongformat") {
            return 'Incorrect format of ' + name;
        } else {
            return 'Please fill in your ' + name;
        }
    }
    wmMinLengthMsg(name, length) {
        return 'The ' + name + ' must have at least ' + length + ' symbols';
    }
    wmEmailLength() {
        return 50;
    }
}
let walkMeFormObj = new WalkMeFormValidation();